"use strict";
module.exports = function (resolve, reject, callback) {
    return {
        error: function (error, meta) {
            if (typeof error === "string") {
                error = { error: error };
            }
            if (meta) {
                error.meta = meta;
            }
            reject(error);
            if (typeof callback === "function") {
                callback(error);
            }
        },
        done: function () {
            var response = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                response[_i] = arguments[_i];
            }
            resolve.apply(this, response);
            if (typeof callback === "function") {
                var args = [null].concat(response);
                callback.apply(this, args);
            }
        },
        to: function (promise) {
            return promise
                .then(function (data) {
                return [null, data];
            })
                .catch(function (err) { return [err]; });
        },
    };
};
