module.exports = function(resolve: any, reject: any, callback: any) {
  return {
    error(error: any, meta?: any) {
      if (typeof error === "string") {
        error = { error }
      }
      if (meta) {
        error.meta = meta
      }
      reject(error)
      if (typeof callback === "function") {
        callback(error)
      }
    },
    done(...response: any[]) {
      resolve.apply(this, response)
      if (typeof callback === "function") {
        const args = [null, ...response]
        callback.apply(this, args)
      }
    },
    to(promise: Promise<any>) {
      return promise
        .then((data) => {
          return [ null, data ]
        })
        .catch((err) => [ err ])
    },
  }
}
